package parser.ast;

import parser.EvaluateContext;
import parser.visitor.ASTVisitor;
import prism.PrismLangException;

/**
 * Store an action in fairness constraints 
 * @author hongyang
 *
 */
public class ExpressionAction extends Expression {
	protected String action;
	protected int index; // index in the action list
	
	public ExpressionAction(String action) {
		this.action = action;
	}
	
	public String getName() {
		return action;
	}
	
	public void setIndex(int index) {
		this.index = index;
	}
	
	public int getIndex() {
		return index;
	}
	
	public Expression deepCopy() {
		return new ExpressionAction(new String(action));
	}

	public Object evaluate(EvaluateContext ec) throws PrismLangException {
		throw new PrismLangException("Cannot evaluate action", this);
	}

	public boolean isConstant() {
		return false;
	}

	public boolean returnsSingleValue() {
		return false;
	}

	public Object accept(ASTVisitor v) throws PrismLangException {
		return v.visit(this);
	}

	public String toString() {
		return "[" + action + "]";
	}

}
