//==============================================================================
//	
//	Copyright (c) 2002-
//	Authors:
//	* Dave Parker <david.parker@comlab.ox.ac.uk> (University of Oxford)
//	
//------------------------------------------------------------------------------
//	
//	This file is part of PRISM.
//	
//	PRISM is free software; you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation; either version 2 of the License, or
//	(at your option) any later version.
//	
//	PRISM is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//	
//	You should have received a copy of the GNU General Public License
//	along with PRISM; if not, write to the Free Software Foundation,
//	Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//	
//==============================================================================

package prism;

/**
 * Set methods to pass options to native code.
 * And a few utility methods, relying on native methods in the "prism" shared library.
 */ 
public class PrismNative
{
	// Load "prism" shared library
	static
	{
		try {
			System.loadLibrary("prism");
		}
		catch (UnsatisfiedLinkError e) {
			System.out.println(e);
			System.exit(1);
		}
	}
	
	// Mode/filename for export of adversaries
	private static native void PN_SetExportAdv(int i);
	public static void setExportAdv(int i)
	{
		PN_SetExportAdv(i);
	}
	
	private static native void PN_SetExportAdvFilename(String filename);
	public static void setExportAdvFilename(String filename)
	{
		PN_SetExportAdvFilename(filename);
	}
	
	// Some miscellaneous native methods
	public static native long PN_GetStdout();
	public static native long PN_OpenFile(String filename);
	public static native long PN_OpenFileAppend(String filename);
	public static native void PN_PrintToFile(long fp, String s);
	public static native void PN_FlushFile(long fp);
	public static native void PN_CloseFile(long fp);
}

//------------------------------------------------------------------------------
